#include <iostream>
#include <vector>
#include "histogram.h"

using namespace std;

struct Input {
    vector<double> numbers;
    size_t bin_count{};
};

Input
input_data() {
    size_t number_count;
    Input in;

    cerr << "Enter number count: ";
    cin >> number_count;
    vector<double> numbers(number_count);

    in.numbers.resize(number_count);

    for (size_t i = 0; i < number_count; i++) {
        cin >> in.numbers[i];
    }

    cerr << "Enter bins count: ";
    cin >> in.bin_count;
    return in;
}

void
show_histogram_text(const vector<size_t>& bins, size_t& bin_count) {
    const size_t SCREEN_WIDTH = 80;
    const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 1;
    size_t max_count = 0;

    for (size_t s = 0; s < bin_count; s++)
    {
        if (bins[s] > max_count)
        {
            max_count = bins[s];
        }
    }

    for (size_t bin : bins)
    {
        if (bin < 100) cout << " ";
        if (bin < 10) cout << " ";
        cout << bin;
        cout << "|";
        size_t height = MAX_ASTERISK * (static_cast<double>(bin) / max_count);
        if (max_count <= MAX_ASTERISK) height = bin;
        for (size_t i = 0; i < height; i++) cout << "*";
        cout << endl;
    }
}

int main()
{
    Input in = input_data();
    vector<size_t> bins = make_histogram(in.numbers, in.bin_count);
    show_histogram_text(bins, in.bin_count);
}
